// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef ENTRANCE_HH
#define ENTRANCE_HH

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "plf_datatypes.hh"
#include "Pingu.hh"
#include "WorldObj.hh"
#include "Direction.hh"

struct entrance_data 
{
  Direction direction;

  ResDescriptor desc;
  int  x_pos;
  int  y_pos;
  int  z_pos;
  int  release_rate;

  void clean() {
    x_pos = 0;
    y_pos = 0;
    z_pos = 0;
    direction.left();
    release_rate = 25;
    desc.res_name = "Hotspot unset - bug in level file";
  }
};

class Entrance : public WorldObj
{
private:
  static CL_Surface* surface;
  int last_release;
  int release_rate;
  Direction direction;
public:
  Entrance(int x, int y);
  Entrance(entrance_data data);
  int x_pos;
  int y_pos;

  bool  pingu_ready();
  Pingu* get_pingu();
  void  draw();
  void draw_offset(int x, int y, double s = 1.0);
};

#endif

/* EOF */
