// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include "blocker.hh"

PinguAction*
make_Blocker(void)
{
  return new Blocker;
}

Blocker::Blocker()
{
}

void
Blocker::init(void)
{
  surface = CL_Res_Surface::load("Pingus/blocker", *local_res());
  counter.set_size(4);
  counter.set_type(Counter::loop);
  is_multi_direct = false;

  while (rel_getpixel(0,-1) == 0) {
    ++pingu->y_pos;
  }
}

void
Blocker::let_move()
{
  /*
    pure aproche to fix the bug, that actions can be set, but they
    will fail immediately after they were set.
    if (rel_getpixel(0,-1) == 0) 
    is_finished = true;
  */
}

bool
Blocker::need_catch()
{
  return true;
}


void
Blocker::catch_pingu(Pingu* pingu_data)
{
  if (pingu_data->x_pos > pingu->x_pos - 16 
      && pingu_data->x_pos < pingu->x_pos + 16
      && pingu_data->y_pos > pingu->y_pos - 2
      && pingu_data->y_pos < pingu->y_pos + 2
      ) 
    {
      if (pingu_data->x_pos > pingu->x_pos )
	pingu_data->direction.right();
      else
	pingu_data->direction.left();
    }
}

bool 
Blocker::can_reset() 
{ 
  return false; 
}

/* EOF */
