// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "digger.hh"
#include "../particles/GroundParticle.hh"
#include "../algo.hh"

PinguAction* 
make_Digger()
{
  return new Digger;
}

Digger::Digger()
{
}

void
Digger::init(void)
{
  surface = CL_Res_Surface::load("Pingus/digger", *local_res());
  counter.set_size(surface->get_no_sprs());
  counter.set_type(Counter::loop);
  counter.set_count(0);
  counter.set_speed(1);

  digger_c.set_size(4);
  digger_c.set_count(0);

  is_multi_direct = false;
}

void
Digger::let_move()
{
  if (++digger_c >= 3) {
    for(int x1 = pingu->x_pos - 15; x1 <= pingu->x_pos + 15; ++x1) {
      pingu->colmap->remove(x1, pingu->y_pos +1);
      pingu->map->remove(x1, pingu->y_pos + 1);
    }
    ++pingu->y_pos;
  }

  pingu->particle->add_particle(new GroundParticle(pingu->x_pos,
						   pingu->y_pos,
						   frand() * 2 - 1,
						   frand() * - 1.5));

  if (rel_getpixel(0, -1) == 0) 
    is_finished = true;
}

/* EOF */
